## apparmor 2.10.95

=== Makefile ===
#
#
.PHONY: all
all:
	@echo "*** See README for information how to build AppArmor ***"
	exit 1

COMMONDIR=common
include ${COMMONDIR}/Make.rules

DIRS=libraries/libapparmor \
     binutils \
     parser \
     utils \
     changehat/mod_apparmor \
     changehat/pam_apparmor \
     profiles \
     tests

#REPO_URL?=lp:apparmor
# --per-file-timestamps is failing over SSH, https://bugs.launchpad.net/bzr/+bug/1257078
REPO_URL?=https://code.launchpad.net/~apparmor-dev/apparmor/master
# alternate possibilities to export from
#REPO_URL=.
#REPO_URL="bzr+ssh://bazaar.launchpad.net/~sbeattie/+junk/apparmor-dev/"

COVERITY_DIR=cov-int
RELEASE_DIR=apparmor-${VERSION}
__SETUP_DIR?=.

# We create a separate version for tags because git can't handle tags
# with embedded ~s in them. No spaces around '-' or they'll get
# embedded in ${VERSION}
TAG_VERSION=$(subst ~,-,${VERSION})

# Add exclusion entries arguments for tar here, of the form:
#   --exclude dir_to_exclude --exclude other_dir
TAR_EXCLUSIONS=

.PHONY: tarball
tarball: clean
	REPO_VERSION=`$(value REPO_VERSION_CMD)` ; \
	make export_dir __EXPORT_DIR=${RELEASE_DIR} __REPO_VERSION=$${REPO_VERSION} ; \
	make setup __SETUP_DIR=${RELEASE_DIR} ; \
	tar ${TAR_EXCLUSIONS} -cvzf ${RELEASE_DIR}.tar.gz ${RELEASE_DIR}

.PHONY: snapshot
snapshot: clean
	$(eval REPO_VERSION:=$(shell $(value REPO_VERSION_CMD)))
	$(eval SNAPSHOT_NAME=apparmor-$(VERSION)~$(REPO_VERSION))
	make export_dir __EXPORT_DIR=${SNAPSHOT_NAME} __REPO_VERSION=${REPO_VERSION} ; \
	make setup __SETUP_DIR=${SNAPSHOT_NAME} ; \
	tar ${TAR_EXCLUSIONS} -cvzf ${SNAPSHOT_NAME}.tar.gz ${SNAPSHOT_NAME} ;

.PHONY: coverity
coverity: snapshot
	cd $(SNAPSHOT_NAME)/libraries/libapparmor && ./configure --with-python
	$(foreach dir, $(filter-out utils profiles tests, $(DIRS)), \
		cov-build --dir $(COVERITY_DIR) -- make -C $(SNAPSHOT_NAME)/$(dir);)
	tar -cvzf $(SNAPSHOT_NAME)-$(COVERITY_DIR).tar.gz $(COVERITY_DIR)

.PHONY: export_dir
export_dir:
	mkdir $(__EXPORT_DIR)
	/usr/bin/bzr export --per-file-timestamps -r $(__REPO_VERSION) $(__EXPORT_DIR) $(REPO_URL)
	echo "$(REPO_URL) $(__REPO_VERSION)" > $(__EXPORT_DIR)/common/.stamp_rev

.PHONY: clean
clean:
	-rm -rf ${RELEASE_DIR} ./apparmor-${VERSION}~* ${COVERITY_DIR}
	for dir in $(DIRS); do \
		make -C $$dir clean; \
	done

.PHONY: setup
setup:
	cd $(__SETUP_DIR)/libraries/libapparmor && ./autogen.sh

.PHONY: tag
tag:
	bzr tag apparmor_${TAG_VERSION}

=== profiles/Makefile ===
# ------------------------------------------------------------------
#
#    Copyright (C) 2002-2009 Novell/SUSE
#    Copyright (C) 2010 Canonical Ltd.
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
#
# ------------------------------------------------------------------

# Makefile for LSM-based AppArmor profiles

NAME=apparmor-profiles
all: local
COMMONDIR=../common/

include $(COMMONDIR)/Make.rules

DESTDIR=/
PROFILES_DEST=${DESTDIR}/etc/apparmor.d
EXTRAS_DEST=${DESTDIR}/usr/share/apparmor/extra-profiles/
PROFILES_SOURCE=./apparmor.d
EXTRAS_SOURCE=./apparmor/profiles/extras/

SUBDIRS=$(shell find ${PROFILES_SOURCE} -type d -print)
TOPLEVEL_PROFILES=$(filter-out ${SUBDIRS}, $(wildcard ${PROFILES_SOURCE}/*))

local:
	for profile in ${TOPLEVEL_PROFILES}; do \
		fn=$$(basename $$profile); \
		echo "# Site-specific additions and overrides for '$$fn'" > ${PROFILES_SOURCE}/local/$$fn; \
		grep "include[[:space:]]\\+<local/$$fn>" "$$profile" >/dev/null || { echo "$$profile doesn't contain #include <local/$$fn>" ; exit 1; } ; \
	done; \

.PHONY: install
install: local
	install -m 755 -d ${PROFILES_DEST}
	install -m 755 -d ${PROFILES_DEST}/disable
	for dir in ${SUBDIRS} ; do \
	    	install -m 755 -d "${PROFILES_DEST}/$${dir#${PROFILES_SOURCE}}" ; \
	done
	for file in $$(find ${PROFILES_SOURCE} -type f -print) ; do \
	    	install -m 644 "$${file}" "${PROFILES_DEST}/$$(dirname $${file#${PROFILES_SOURCE}})" ; \
	done
	install -m 755 -d ${EXTRAS_DEST}
	install -m 644 ${EXTRAS_SOURCE}/* ${EXTRAS_DEST}

LOCAL_ADDITIONS=$(filter-out ${PROFILES_SOURCE}/local/README, $(wildcard ${PROFILES_SOURCE}/local/*))
.PHONY: clean
clean:
	-rm -f ${LOCAL_ADDITIONS}

ifndef VERBOSE
  Q=@
else
  Q=
endif

ifndef PARSER
# use system parser
PARSER=../parser/apparmor_parser
endif

ifndef LOGPROF
# use ../utils logprof
LOGPROF=PYTHONPATH=../utils $(PYTHON) ../utils/aa-logprof
endif

IGNORE_FILES=${EXTRAS_SOURCE}/README
CHECK_PROFILES=$(filter-out ${IGNORE_FILES} ${SUBDIRS}, $(wildcard ${PROFILES_SOURCE}/*) $(wildcard ${EXTRAS_SOURCE}/*))

.PHONY: check
check: check-parser check-logprof

.PHONY: check-parser
check-parser: local
	@echo "*** Checking profiles from ${PROFILES_SOURCE} and ${EXTRAS_SOURCE} against apparmor_parser"
	$(Q)for profile in ${CHECK_PROFILES} ; do \
	        [ -n "${VERBOSE}" ] && echo "Testing $${profile}" ; \
		${PARSER} -S -b ${PWD}/apparmor.d $${profile} > /dev/null || exit 1; \
	done

.PHONY: check-logprof
check-logprof: local
	@echo "*** Checking profiles from ${PROFILES_SOURCE} against logprof"
	$(Q)${LOGPROF} -d ${PROFILES_SOURCE} -f /dev/null || exit 1

=== utils/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 1999, 2004-2009 NOVELL (All rights reserved)
#    Copyright (c) 2010-2011 Canonical Ltd.
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME 		= apparmor-utils
all:
COMMONDIR=../common/

include $(COMMONDIR)/Make.rules

PERLTOOLS = aa-notify
PYTOOLS = aa-easyprof aa-genprof aa-logprof aa-cleanprof aa-mergeprof \
          aa-autodep aa-audit aa-complain aa-enforce aa-disable \
	  aa-status aa-unconfined
TOOLS = ${PERLTOOLS} ${PYTOOLS} aa-decode
PYSETUP = python-tools-setup.py
PYMODULES = $(wildcard apparmor/*.py apparmor/rule/*.py)

MANPAGES = ${TOOLS:=.8} logprof.conf.5

all: ${MANPAGES} ${HTMLMANPAGES}
	$(MAKE) -C po all
	$(MAKE) -C vim all

# need some better way of determining this
DESTDIR=/
BINDIR=${DESTDIR}/usr/sbin
CONFDIR=${DESTDIR}/etc/apparmor
PYPREFIX=/usr

PYFLAKES=pyflakes

po/${NAME}.pot: ${TOOLS} ${PYMODULES}
	$(MAKE) -C po ${NAME}.pot NAME=${NAME} SOURCES="${TOOLS} ${PYMODULES}"

.PHONY: install
install: ${MANPAGES} ${HTMLMANPAGES}
	install -d ${CONFDIR}
	install -m 644 logprof.conf severity.db notify.conf ${CONFDIR}
	install -d ${BINDIR}
	ln -sf aa-status ${BINDIR}/apparmor_status
	# aa-easyprof is installed by python-tools-setup.py
	install -m 755 $(filter-out aa-easyprof, ${TOOLS}) ${BINDIR}
	$(MAKE) -C po install DESTDIR=${DESTDIR} NAME=${NAME}
	$(MAKE) install_manpages DESTDIR=${DESTDIR}
	$(MAKE) -C vim install DESTDIR=${DESTDIR}
	ln -sf aa-status.8 ${DESTDIR}/${MANDIR}/man8/apparmor_status.8
	${PYTHON} ${PYSETUP} install --prefix=${PYPREFIX} --root=${DESTDIR} --version=${VERSION}

.PHONY: clean
ifndef VERBOSE
.SILENT: clean
endif
clean: pod_clean
	rm -f core core.* *.o *.s *.a *~
	$(MAKE) -C po clean
	$(MAKE) -C vim clean
	$(MAKE) -C test clean
	rm -rf staging/ build/
	rm -f apparmor/*.pyc apparmor/rule/*.pyc
	rm -rf apparmor/__pycache__/ apparmor/rule/__pycache__/

# ${CAPABILITIES} is defined in common/Make.rules
.PHONY: check_severity_db
.SILENT: check_severity_db
check_severity_db: /usr/include/linux/capability.h severity.db
	# The sed statement is based on the one in the parser's makefile
	RC=0 ; for cap in ${CAPABILITIES} ; do \
	    if !  grep -q -w $${cap} severity.db ; then \
		echo "Warning! capability $${cap} not found in severity.db" ; \
		RC=1 ; \
	    fi ;\
	done ; \
	test "$$RC" -eq 0

# check_pod_files is defined in common/Make.rules
.PHONY: check
.SILENT: check
check: check_severity_db check_pod_files
	for i in ${PERLTOOLS} ; do \
		perl -c $$i || exit 1; \
	done
	for i in ${PYTOOLS} apparmor test/*.py; do \
		echo Checking $$i; \
		$(PYFLAKES) $$i || exit 1; \
	done
	$(MAKE) -C test check
	$(MAKE) -C vim check

=== changehat/mod_apparmor/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 2004, 2005 NOVELL (All rights reserved)
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME:=apache2-mod_apparmor
all:
COMMONDIR=../../common/

include $(COMMONDIR)/Make.rules

TARGET:=mod_apparmor.so
MANPAGES=mod_apparmor.8

APXS:=$(shell if [ -x "/usr/sbin/apxs2" ] ; then \
		echo "/usr/sbin/apxs2" ; \
              elif [ -x "/usr/sbin/apxs" ] ; then \
	        echo "/usr/sbin/apxs" ; \
              elif [ -x "/usr/bin/apxs2" ] ; then \
	        echo "/usr/bin/apxs2" ; \
              elif [ -x "/usr/bin/apxs" ] ; then \
	        echo "/usr/bin/apxs" ; \
              else \
	        echo "apxs" ; \
	      fi ) 
APXS_INSTALL_DIR=$(shell ${APXS} -q LIBEXECDIR)
DESTDIR=
ifdef USE_SYSTEM
  LIBAPPARMOR = $(shell if pkg-config --exists libapparmor ; then \
                                pkg-config --silence-errors --libs libapparmor ; \
                        elif ldconfig -p | grep -q libapparmor\.so$$ ; then \
                                echo -lapparmor ; \
                        fi )
  ifeq ($(strip $(LIBAPPARMOR)),)
    ERROR_MESSAGE = $(error ${nl}\
************************************************************************${nl}\
Unable to find libapparmor installed on this system; either${nl}\
install libapparmor devel packages, set the LIBAPPARMOR variable${nl}\
manually, or build against in-tree libapparmor.${nl}\
************************************************************************${nl})
  endif # LIBAPPARMOR not set
  LDLIBS += $(LIBAPPARMOR)
else
  LIBAPPARMOR_SRC := ../../libraries/libapparmor/
  LIBAPPARMOR_INCLUDE = $(LIBAPPARMOR_SRC)/include
  LIBAPPARMOR_PATH := $(LIBAPPARMOR_SRC)/src/.libs/
    ifeq ($(realpath $(LIBAPPARMOR_PATH)/libapparmor.a),)
        ERROR_MESSAGE = $(error ${nl}\
************************************************************************${nl}\
$(LIBAPPARMOR_PATH)/libapparmor.a is missing; either build against${nl}\
the in-tree libapparmor by building it first and then trying again${nl}\
(see the top-level README for help) or build against the system${nl}\
libapparmor by adding USE_SYSTEM=1 to your make command.${nl}\
************************************************************************${nl})
    endif
  # Need to pass -Wl twice here to get past both apxs2 and libtool, as
  # libtool will add the path to the RPATH of the library if passed -L/some/path
  LIBAPPARMOR_FLAGS = -I$(LIBAPPARMOR_INCLUDE) -Wl,-Wl,-L$(LIBAPPARMOR_PATH)
  LDLIBS = -lapparmor
endif

.PHONY: libapparmor_check
.SILENT: libapparmor_check
libapparmor_check: ; $(ERROR_MESSAGE)

all: libapparmor_check $(TARGET) ${MANPAGES} ${HTMLMANPAGES}

%.so: %.c
	${APXS} ${LIBAPPARMOR_FLAGS} -c $< ${LDLIBS}
	mv .libs/$@ .

.PHONY: install
install: ${TARGET} ${MANPAGES}
	mkdir -p ${DESTDIR}/${APXS_INSTALL_DIR}
	install -m 755 $< ${DESTDIR}/${APXS_INSTALL_DIR}
	make install_manpages DESTDIR=${DESTDIR}

.PHONY: clean
clean: pod_clean
	rm -rf .libs
	rm -f *.la *.lo *.so *.o *.slo

.PHONY: check
check: check_pod_files

=== parser/libapparmor_re/Makefile ===
# Profiling:
#EXTRA_CFLAGS = -pg

ifdef USE_SYSTEM
  # Using the system libapparmor
  INCLUDE_APPARMOR =
else
  INCLUDE_APPARMOR = -I../../libraries/libapparmor/include
endif

TARGET=libapparmor_re.a

CFLAGS ?= -g -Wall -O2 ${EXTRA_CFLAGS} -std=gnu++0x
CXXFLAGS := ${CFLAGS} ${INCLUDE_APPARMOR}

ARFLAGS=-rcs

BISON := bison

all : ${TARGET}

UNITTESTS = tst_parse

libapparmor_re.a: parse.o expr-tree.o hfa.o chfa.o aare_rules.o
	ar ${ARFLAGS} $@ $^

expr-tree.o: expr-tree.cc expr-tree.h

hfa.o: hfa.cc apparmor_re.h hfa.h ../immunix.h

aare_rules.o: aare_rules.cc aare_rules.h apparmor_re.h expr-tree.h hfa.h chfa.h parse.h ../immunix.h

chfa.o: chfa.cc chfa.h ../immunix.h

parse.o : parse.cc apparmor_re.h expr-tree.h

parse.cc : parse.y parse.h flex-tables.h ../immunix.h
	${BISON} -o $@ $<

clean:
	rm -f *.o parse.cc ${TARGET} *.gcda *.gcno

=== tests/stress/Makefile ===
SUBDIRS=subdomain

.PHONY: clean
clean:
	for dir in $(SUBDIRS) ; do \
		make clean -C $${dir} ; \
	done

=== utils/test/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 1999, 2004-2009 NOVELL (All rights reserved)
#    Copyright (c) 2010-2014 Canonical Ltd.
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME 		= apparmor-utils
all:
COMMONDIR=../../common/

include $(COMMONDIR)/Make.rules

ifdef USE_SYSTEM
    LD_LIBRARY_PATH=
    PYTHONPATH=
else
    # PYTHON_DIST_BUILD_PATH based on libapparmor/swig/python/test/Makefile.am
    PYTHON_DIST_BUILD_PATH = ../../libraries/libapparmor/swig/python/build/$$($(PYTHON) -c "import distutils.util; import platform; print(\"lib.%s-%s\" %(distutils.util.get_platform(), platform.python_version()[:3]))")
    LD_LIBRARY_PATH=../../libraries/libapparmor/src/.libs/
    PYTHONPATH=..:$(PYTHON_DIST_BUILD_PATH)
endif

.PHONY: __libapparmor
__libapparmor:
ifndef USE_SYSTEM
	@if [ ! -f $(LD_LIBRARY_PATH)libapparmor.so ]; then \
		echo "error: $(LD_LIBRARY_PATH)libapparmor.so is missing. Pick one of these possible solutions:" 1>&2; \
		echo "  1) Build against the in-tree libapparmor by building it first and then trying again. See the top-level README for help." 1>&2; \
		echo "  2) Build against the system libapparmor by adding USE_SYSTEM=1 to your make command." 1>&2; \
		return 1; \
	fi
endif

COVERAGE_OMIT=test-*.py,common_test.py
ifneq ($(COVERAGE_OUT), )
HTML_COVR_ARGS=-d $(COVERAGE_OUT)
endif

# use   make COVERAGE_IGNORE_FAILURES=true coverage   to build coverage data even if some tests fail
ifeq ($(COVERAGE_IGNORE_FAILURES), true)
  COVERAGE_IGNORE_FAILURES_CMD=true
else
  COVERAGE_IGNORE_FAILURES_CMD=set -e
endif

.PHONY: clean check coverage coverage-report coverage-html
ifndef VERBOSE
.SILENT: clean check .coverage coverage coverage-report coverage-html
endif

clean:
	rm -rf __pycache__/ .coverage htmlcov

check: __libapparmor
	export PYTHONPATH=$(PYTHONPATH) ; export LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) ; $(foreach test, $(wildcard test-*.py), echo ; echo === $(test) === ; $(call pyalldo, $(test)))

.coverage: $(wildcard ../aa-* ../apparmor/*.py test-*.py) __libapparmor
	export PYTHONPATH=$(PYTHONPATH) ; export LD_LIBRARY_PATH=$(LD_LIBRARY_PATH); $(COVERAGE_IGNORE_FAILURES_CMD) ; $(foreach test, $(wildcard test-*.py), echo ; echo === $(test) === ; $(PYTHON) -m coverage run --branch -p $(test); )
	$(PYTHON) -m coverage combine

coverage: .coverage

coverage-report: .coverage
	$(PYTHON) -m coverage report --omit="$(COVERAGE_OMIT)"

coverage-html: .coverage
	$(PYTHON) -m coverage html --omit="$(COVERAGE_OMIT)" $(HTML_COVR_ARGS)

=== tests/regression/apparmor/Makefile ===
#	Copyright (C) 2002-2005 Novell/SUSE
#	Copyright (C) 2013 Canonical, Ltd
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License as
#	published by the Free Software Foundation, version 2 of the
#	License.

all:
COMMONDIR=../../../common/
include $(COMMONDIR)/Make.rules

ifdef USE_SYSTEM
  # use the system libapparmor headers and library
  LIBAPPARMOR = $(shell if pkg-config --exists libapparmor ; then \
				pkg-config --silence-errors --libs libapparmor ; \
			elif ldconfig -p | grep -q libapparmor\.so$$ ; then \
				echo -lapparmor ; \
			fi )
  ifeq ($(strip $(LIBAPPARMOR)),)
    LIBAPPARMOR_ERROR_MESSAGE = $(error ${nl}\
************************************************************************${nl}\
Unable to find libapparmor installed on this system; either${nl}\
install libapparmor devel packages, set the LIBAPPARMOR variable${nl}\
manually, or build against in-tree libapparmor.${nl}\
************************************************************************${nl})
  endif # LIBAPPARMOR not set
  LDLIBS += $(LIBAPPARMOR)

  AA_EXEC = $(shell which aa-exec)
  ifeq ($(AA_EXEC),)
    AA_EXEC_ERROR_MESSAGE = $(error ${nl}\
************************************************************************${nl}\
Unable to find aa-exec installed on this system; either install the${nl}\
apparmor package, set the AA_EXEC variable manually, or use the in-tree${nl}\
aa-exec.${nl}\
************************************************************************${nl})
  endif # AA_EXEC not set

else # !USE_SYSTEM
  # use in-tree versions
  LIBAPPARMOR_SRC := ../../../libraries/libapparmor/
  LIBAPPARMOR_INCLUDE = $(LIBAPPARMOR_SRC)/include
  LIBAPPARMOR_PATH := $(LIBAPPARMOR_SRC)/src/.libs/
  ifeq ($(realpath $(LIBAPPARMOR_PATH)/libapparmor.a),)
        LIBAPPARMOR_ERROR_MESSAGE = $(error ${nl}\
************************************************************************${nl}\
$(LIBAPPARMOR_PATH)/libapparmor.a is missing; either build against${nl}\
the in-tree libapparmor by building it first and then trying again${nl}\
(see the top-level README for help) or build against the system${nl}\
libapparmor by adding USE_SYSTEM=1 to your make command.${nl}\
************************************************************************${nl})
  endif

  BINUTILS_SRC := ../../../binutils
  AA_EXEC = $(BINUTILS_SRC)/aa-exec
  ifeq ($(realpath $(AA_EXEC)),)
        AA_EXEC_ERROR_MESSAGE = $(error ${nl}\
************************************************************************${nl}\
$(AA_EXEC) is missing; either build the $(BINUTILS_SRC) directory${nl}\
and then try again (see the top-level README for help) or use the${nl}\
system aa-exec by adding USE_SYSTEM=1 to your make command.${nl}\
************************************************************************${nl})
  endif

  CFLAGS += -L$(LIBAPPARMOR_PATH) -I$(LIBAPPARMOR_INCLUDE)
  LDLIBS += -Wl,-Bstatic -lapparmor -Wl,-Bdynamic -lpthread
endif # USE_SYSTEM

CFLAGS += -g -O0 -Wall -Wstrict-prototypes

SRC=access.c \
    introspect.c \
    changeprofile.c \
    onexec.c \
    changehat.c \
    changehat_fork.c \
    changehat_misc.c \
    changehat_misc2.c \
    changehat_twice.c \
    changehat_fail.c \
    changehat_wrapper.c \
    changehat_pthread.c \
    chdir.c \
    chgrp.c \
    chmod.c \
    chown.c \
    clone.c \
    coredump.c \
    deleted.c \
    environ.c \
    env_check.c \
    exec.c \
    exec_qual.c \
    exec_qual2.c \
    fchdir.c \
    fchgrp.c \
    fchmod.c \
    fchown.c \
    fd_inheritance.c \
    fd_inheritor.c \
    fork.c \
    link.c \
    link_subset.c \
    mmap.c \
    mkdir.c \
    mount.c \
    named_pipe.c \
    net_raw.c \
    open.c \
    openat.c \
    pipe.c \
    pivot_root.c \
    ptrace.c \
    ptrace_helper.c \
    pwrite.c \
    query_label.c \
    rename.c \
    readdir.c \
    rw.c \
    socketpair.c \
    symlink.c \
    syscall_mknod.c \
    swap.c \
    syscall_chroot.c \
    syscall_mlockall.c \
    syscall_ptrace.c \
    syscall_reboot.c \
    syscall_setpriority.c \
    syscall_sethostname.c \
    syscall_setdomainname.c \
    syscall_setscheduler.c \
    syscall_sysctl.c \
    sysctl_proc.c \
    tcp.c \
    unix_fd_client.c \
    unix_fd_server.c \
    unix_socket.c \
    unix_socket_client.c \
    unlink.c \
    xattrs.c

#only do the ioperm/iopl tests for x86 derived architectures
ifneq (,$(findstring $(shell uname -i),i386 i486 i586 i686 x86 x86_64))
SRC+=syscall_ioperm.c syscall_iopl.c
endif

#only do dbus if proper libs are installl
ifneq (,$(shell pkg-config --exists dbus-1 && echo TRUE))
SRC+=dbus_eavesdrop.c dbus_message.c dbus_service.c dbus_unrequested_reply.c
else
$(warning ${nl}\
************************************************************************${nl}\
No dbus pkg-config skipping dbus_eavesdrop dbus_message dbus_services tests ...${nl}\
Install libdbus-1-dev or equivalent package to build and run these tests${nl}\
************************************************************************${nl})
endif

ifdef USE_SYSTEM
  ifneq (,$(shell pkg-config --atleast-version 2.10 libapparmor && echo TRUE))
    SRC+=aa_policy_cache.c
    CONDITIONAL_TESTS+=aa_policy_cache
  else
    $(warning ${nl}\
    ************************************************************************${nl}\
    Skipping aa_policy_cache tests: requires libapparmor 2.10 or newer ...${nl}\
    ************************************************************************${nl})
  endif

  ifneq (,$(shell pkg-config --atleast-version 2.11 libapparmor && echo TRUE))
    SRC+=stacking.c
    CONDITIONAL_TESTS+=exec_stack stackonexec stackprofile
  else
    $(warning ${nl}\
    ************************************************************************${nl}\
    Skipping stacking tests: requires libapparmor 2.11 or newer ...${nl}\
    ************************************************************************${nl})
  endif
else
  SRC+=aa_policy_cache.c stacking.c
  CONDITIONAL_TESTS+=exec_stack aa_policy_cache stackonexec stackprofile
endif

EXEC=$(SRC:%.c=%)

TESTS=aa_exec \
      access \
      introspect \
      capabilities \
      changeprofile \
      onexec \
      changehat \
      changehat_fork \
      changehat_misc \
      chdir \
      clone \
      coredump \
      deleted \
      environ \
      exec \
      exec_qual \
      fchdir \
      fd_inheritance \
      fork \
      i18n \
      link \
      link_subset \
      mkdir \
      mmap \
      mount \
      mult_mount \
      named_pipe \
      namespaces \
      net_raw \
      open \
      openat \
      pipe \
      pivot_root \
      ptrace \
      pwrite \
      query_label \
      regex \
      rename \
      readdir \
      rw \
      socketpair \
      swap \
      sd_flags \
      setattr \
      symlink \
      syscall \
      tcp \
      unix_fd_server \
      unix_socket_pathname \
      unix_socket_abstract \
      unix_socket_unnamed \
      unlink\
      xattrs\
      longpath

#only do dbus if proper libs are installl
ifneq (,$(shell pkg-config --exists dbus-1 && echo TRUE))
TESTS+=dbus_eavesdrop dbus_message dbus_service dbus_unrequested_reply
endif

TESTS+=$(CONDITIONAL_TESTS)

# Tests that can crash the kernel should be placed here
RISKY_TESTS=

.PHONY: libapparmor_check
.SILENT: libapparmor_check
libapparmor_check: ; $(LIBAPPARMOR_ERROR_MESSAGE)

aa_exec_check: ; $(AA_EXEC_ERROR_MESSAGE)

all: libapparmor_check aa_exec_check $(EXEC) changehat.h uservars.inc

uservars.inc: uservars.inc.source uservars.inc.system
ifdef USE_SYSTEM
	cp uservars.inc.system uservars.inc
else # !USE_SYSTEM
	cp uservars.inc.source uservars.inc
endif # USE_SYSTEM

changehat_pthread: changehat_pthread.c changehat.h
	${CC} ${CFLAGS} ${LDFLAGS} $< -o $@ ${LDLIBS} -pthread

dbus_common.o: dbus_common.c dbus_common.h
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS} $(shell pkg-config --cflags --libs dbus-1)

dbus_eavesdrop: dbus_eavesdrop.c dbus_common.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS} $(shell pkg-config --cflags --libs dbus-1)

dbus_message: dbus_message.c dbus_common.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS} $(shell pkg-config --cflags --libs dbus-1)

dbus_service: dbus_message dbus_service.c dbus_common.o
	${CC} ${CFLAGS} ${LDFLAGS} $(filter-out dbus_message, $^) -o $@ ${LDLIBS} $(shell pkg-config --cflags --libs dbus-1)

dbus_unrequested_reply: dbus_service dbus_unrequested_reply.c dbus_common.o
	${CC} ${CFLAGS} ${LDFLAGS} $(filter-out dbus_service, $^) -o $@ ${LDLIBS} $(shell pkg-config --cflags --libs dbus-1)

unix_socket_common.o: unix_socket_common.c unix_socket_common.h
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

unix_socket_client: unix_socket_client.c unix_socket_common.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

unix_socket: unix_socket.c unix_socket_common.o unix_socket_client
	${CC} ${CFLAGS} ${LDFLAGS} $(filter-out unix_socket_client, $^) -o $@ ${LDLIBS}

tests: all
	@if [ `whoami` = "root" ] ;\
	then \
		rc=0; \
		for i in $(TESTS) ;\
		do \
			echo ;\
			echo "running $$i" ;\
			bash $$i.sh ;\
			if [ $$? -ne 0 ] ; then \
				rc=1;\
			fi;\
		done ;\
		exit $$rc;\
	else \
		echo "must be root to run tests" ;\
		exit 1;\
	fi

alltests: all
	@if [ `whoami` = "root" ] ;\
	then \
		rc=0; \
		for i in $(TESTS) $(RISKY_TESTS) ;\
		do \
			echo ;\
			echo "running $$i" ;\
			bash $$i.sh ;\
			if [ $$? -ne 0 ] ; then \
				rc=1;\
			fi;\
		done ;\
		exit $$rc;\
	else \
		echo "must be root to run tests" ;\
		exit 1;\
	fi

clean:
	rm -f $(EXEC) dbus_common.o unix_socket_common.o uservars.inc

regex.sh: open exec

=== debian/changelog ===
apparmor (2.10.95-4~bpo8+2) jessie-backports; urgency=medium

  * Drop Breaks: lightdm (<< 1.11.8-0ubuntu2~).
    It was added in Ubuntu because lightdm 1.11.8-0ubuntu2 brings "updates
    for unix socket mediation". But Unix socket mediation requires
    third-party Linux kernel patches, that we haven't in Debian.
    So better not break the "Jessie user who need lightdm and want the
    apparmor backport" use case.

 -- intrigeri <intrigeri@debian.org>  Wed, 20 Jul 2016 19:47:08 +0000

apparmor (2.10.95-4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- intrigeri <intrigeri@debian.org>  Thu, 07 Jul 2016 11:06:13 +0000

apparmor (2.10.95-4) unstable; urgency=medium

  * debhelper/postinst-apparmor: re-add the "aa-status --enabled" -based code
    as a fallback, that is used when aa-enabled is not present. This
    facilitates upgrades from Jessie to Stretch, as well as partial
    testing/sid upgrades. (Closes: #829030)

 -- intrigeri <intrigeri@debian.org>  Fri, 01 Jul 2016 12:50:58 +0000

apparmor (2.10.95-3) unstable; urgency=medium

  * debhelper/postinst-apparmor: re-add 2>/dev/null to aa-enabled invocation,
    to avoid misleading users into thinking the package is missing a dependency
    on apparmor. Thanks to Simon McVittie for the analysis! (Closes: #828795)

 -- intrigeri <intrigeri@debian.org>  Wed, 29 Jun 2016 10:11:30 +0000

apparmor (2.10.95-2) unstable; urgency=medium

  * dh-apparmor: use aa-enabled instead of aa-status --enabled.
    (Closes: #822475)
  * Ship fake aa-enabled and aa-exec for non-Linux builds to fix FTBFS there
    (same "solution" as the one we've had for apparmor_parser for a while).

 -- intrigeri <intrigeri@debian.org>  Fri, 24 Jun 2016 13:16:20 +0000

apparmor (2.10.95-1) unstable; urgency=medium

  * Merge from ubuntu-citrain up to revision 1590, that is changes brought
    by 2.10.95-0ubuntu1 to 2.10.95-0ubuntu2, including a new upstream
    release also known as AppArmor 2.11.beta1. (Closes: #810888)
    Remaining changes:
    - debian/apparmor.install: install tunables/home.d and tunables/multiarch.*,
      to make it easier to maintain site-specific configuration.
    - Don't ship empty /usr/bin and /usr/share/apparmor in apparmor-utils:
      I fail to see what good they can do.
    - Drop dependency from apparmor on initramfs-tools: the early modules
      loading code that needed it was removed a while ago.
    - apparmor-notify depends on libnotify-bin: the package's description
      is explicitly about desktop notifications, and we've had #746508,
      so let's stick to supporting the desktop use case as best as we can,
      and ignore the server use case for now.
    - debian/control: removed duplicated Section entry for apparmor-easyprof,
      it's the same as the source package's one.
    - Apply notify-group.patch.
    - The new packaging fixes and improvements documented below.
  * Remove Holger from Uploaders, at his request. (Closes: #824461)
  * dh-apparmor: fix enabling policy if it's the system's first.
    Thanks to Peter Palfrader <weasel@debian.org> for the analysis and patch!
    (Closes: #822349)
  * Declare compliance with Standards-Version 3.9.8.
  * Fix typo in dh_apparmor(1) manpage.
  * Add Lintian overrides for the no-upstream-changelog check: upstream
    does not ship any changelog.
  * debian/README.source: document how we import new upstream releases
    from Ubuntu into Debian.
  * Add a systemd unit wrapping the init script. Thanks to Felipe Sateler
    for coming up with a patch, to the OpenSUSE folks for some inspiration,
    and to Felix Geyer for commenting on my own initial draft. (Closes: #796589)
    Accordingly:
    - Add a build-dependency on dh-systemd, and enable it in debian/rules.
    - Disable handle_system_policy_package_updates in the init script's
      start action: it is only useful for click, snappy and Ubuntu system
      images, i.e. not in Debian; and it reads and writes to /var, that can
      be remote-mounted, so it would prevent us from using Before=sysinit.target
      (and thus, from confining early system services) without possibly
      introducing dependency loops.

 -- intrigeri <intrigeri@debian.org>  Thu, 23 Jun 2016 18:25:09 +0000

apparmor (2.10.95-0ubuntu2) xenial; urgency=medium

  * debian/patches/r3435-allow-dnsmasq-access-to-lxd-bridge.patch: Grant
    access to the new default bridge configuration in LXD 2.0.0 (LP: #1566944)
  * debian/patches/r3437-add-attach-disconnected-to-dnsmasq.patch: Add the
    attach_disconnected flag to the dnsmasq profile in order to prevent a
    disconnected path denial triggered by the latest network-manager upload
    (LP: #1569316)
  * debian/lib/apparmor/functions: Reference the new path used for snapd
    AppArmor profiles to fix a bug which left those profiles unloaded after
    booting (LP: #1569573)

 -- Tyler Hicks <tyhicks@canonical.com>  Tue, 12 Apr 2016 16:59:46 -0500

apparmor (2.10.95-0ubuntu1) xenial; urgency=medium

  * Update to apparmor 2.10.95 (2.11 Beta 1) (LP: #1561762)
    - Allow Apache prefork profile to chown(2) files (LP: #1210514)
    - Allow deluge-gtk and deluge-console to handle torrents opened in
      browsers (LP: #1501913)
    - Allow file accesses needed by some programs using libnl-3-200
      (Closes: #810888)
    - Allow file accesses needed on systems that use NetworkManager without
      resolvconf (Closes: #813835)
    - Adjust aa-status(8) to work without python3-apparmor (LP: #1480492)
    - Fix aa-logprof(8) crash when operating on files containing multiple
      profiles with certain rules (LP: #1528139)
    - Fix log parsing crashes, in the Python utilities, caused by certain file
      related events (LP: #1525119, LP: #1540562)
    - Fix log parsing crasher, in the Python utilities, caused by certain
      change_hat events (LP: #1523297)
    - Improve Python 2 support of the utils by fixing an aa-logprof(8) crasher


=== debian/control ===
Source: apparmor
Section: admin
Priority: extra
Maintainer: Debian AppArmor Team <pkg-apparmor-team@lists.alioth.debian.org>
Uploaders:
  intrigeri <intrigeri@debian.org>,
  Kees Cook <kees@debian.org>
Build-Depends: debhelper (>= 9.20120322~), po-debconf, dpkg-dev (>= 1.16.1~),
    autotools-dev, libtool, automake, autoconf, chrpath,
    flex, bison,
    dejagnu,
    swig,
    bzip2,
    apache2-dev, dh-apache2,
    libpam-dev,
    texlive-latex-base, texlive-latex-recommended,
    python-all-dev, python, python3-all-dev, python3,
    perl (>= 5.8.0), liblocale-gettext-perl, pkg-config,
    dh-systemd
Standards-Version: 3.9.8
Homepage: http://apparmor.net/
Vcs-Bzr: https://anonscm.debian.org/bzr/collab-maint/apparmor
Vcs-Browser: https://alioth.debian.org/scm/loggerhead/collab-maint/apparmor/changes

Package: apparmor
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libapparmor-perl, lsb-base, debconf
Breaks: libapache2-mod-apparmor (<< 2.5.1-0ubuntu3), apparmor-utils (<< 2.8.0-0ubuntu28), libvirt-bin (<< 1.2.6-0ubuntu6~), apparmor-easyprof-ubuntu (<< 1.2.22), rsyslog (<< 7.4.4-1ubuntu9~), lxc (<< 1.1.0~alpha1-0ubuntu5~)
Replaces: apparmor-parser, libapache2-mod-apparmor (<< 2.5.1-0ubuntu3), apparmor-utils (<< 2.8.0-0ubuntu28)
Suggests: apparmor-profiles, apparmor-profiles-extra, apparmor-docs, apparmor-utils
Description: user-space parser utility for AppArmor
 This provides the system initialization scripts needed to use the
 AppArmor Mandatory Access Control system, including the AppArmor Parser
 which is required to convert AppArmor text profiles into machine-readable
 policies that are loaded into the kernel for use with the AppArmor Linux
 Security Module.

Package: apparmor-utils
Architecture: any
Depends: apparmor (>= 2.6.1-4ubuntu1), libapparmor-perl, python3-apparmor (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${python3:Depends}
Suggests: apparmor-docs, vim-addon-manager
Description: utilities for controlling AppArmor
 This provides the utilities to operate on AppArmor profiles. Profiles
 can be created, updated, enforced, set to complain mode, and disabled
 with tools such as aa-genprof, aa-enforce, aa-complain and aa-disabled.

Package: apparmor-profiles
Architecture: all
Depends: apparmor (>= 2.8.96~2535-0ubuntu1~), ${misc:Depends}
Description: profiles for AppArmor Security policies
 This provides various AppArmor profiles that have not been shipped by
 the packages they provide confinement for. By default, they ship in
 complain mode so that users can test and choose which are desired.

Package: apparmor-docs
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation for AppArmor
 This package provides some technical documentation for the AppArmor
 Mandatory Access Control system. Currently this is only a single
 PDF covering basic operation, written some time ago.

Package: libapparmor-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libapparmor1 (= ${binary:Version}), ${misc:Depends}
Breaks: libapparmor1 ( << 2.8.95~2395-0ubuntu1 ), apparmor-docs ( << 2.8.95~2395-0ubuntu1 )
Replaces: libapparmor1 ( << 2.8.95~2395-0ubuntu1 ), apparmor-docs ( << 2.8.95~2395-0ubuntu1 )
Description: AppArmor development libraries and header files
 This package provides the development libraries and header files needed to
 link against the AppArmor changehat and log parsing functions. Also
 includes the manpages for library functions.

Package: libapparmor1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: changehat AppArmor library
 This package provides the shared library used for making use of the
 AppArmor profile and changehat functionality, as well as common log
 parsing routines.

Package: libapparmor-perl
Section: perl
Architecture: any
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: AppArmor library Perl bindings
 This provides the Perl module that contains the language bindings
 for the AppArmor library, libapparmor, which were autogenerated via
 SWIG.

Package: libapache2-mod-apparmor
Pre-Depends: ${misc:Pre-Depends}
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: changehat AppArmor library as an Apache module
 This provides the Apache module needed to declare various differing
 confinement policies when running virtual hosts in the webserver
 by using the changehat abilities exposed through libapparmor.

Package: libpam-apparmor
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: changehat AppArmor library as a PAM module
 This provides the PAM module needed to declare various differing
 confinement policies when starting PAM sessions by using the
 changehat abilities exposed through libapparmor.

Package: apparmor-notify
Architecture: all
Depends: libapparmor-perl, ${perl:Depends}, ${misc:Depends}, libnotify-bin
Description: AppArmor notification system
 This package provides a utility to display AppArmor denial messages via
 desktop notifications. The utility can also be used to generate summary
 reports.

Package: python-libapparmor
Section: python
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
XS-Python-Version: ${python:Versions}
Description: AppArmor library Python bindings
 This provides the Python module that contains the language bindings
 for the AppArmor library, libapparmor, which were autogenerated via
 SWIG.

Package: python3-libapparmor
Section: python
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
XS-Python-Version: ${python3:Versions}
Description: AppArmor library Python3 bindings
 This provides the Python3 module that contains the language bindings
 for the AppArmor library, libapparmor, which were autogenerated via
 SWIG.

Package: python-apparmor
Section: python
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}, python-libapparmor (>= ${source:Upstream-Version}), python-pkg-resources
Breaks: apparmor-utils ( << 2.8.95~2385-0ubuntu1 )
Replaces: apparmor-utils ( << 2.8.95~2385-0ubuntu1 )
XS-Python-Version: ${python:Versions}
Description: AppArmor Python utility library
 This provides the Python modules that implement the higher-level AppArmor
 applications.

Package: python3-apparmor
Section: python
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, python3-libapparmor (>= ${source:Upstream-Version}), python3-pkg-resources
Breaks: apparmor-easyprof ( << 2.8.95~2385-0ubuntu1 ), apparmor-utils ( << 2.8.95~2385-0ubuntu1 )
Replaces: apparmor-easyprof ( << 2.8.95~2385-0ubuntu1 ), apparmor-utils ( << 2.8.95~2385-0ubuntu1 )
XS-Python-Version: ${python3:Versions}
Description: AppArmor Python3 utility library
 This provides the Python3 modules that implement the higher-level AppArmor
 applications.

Package: dh-apparmor
Section: devel
Architecture: all
Multi-Arch: foreign
Depends: ${perl:Depends}, ${misc:Depends}
Suggests: apparmor-easyprof
Breaks: debhelper (<< 9.20120115ubuntu3)
Replaces: debhelper (<< 9.20120115ubuntu3)
Description: AppArmor debhelper routines
 This provides the debhelper tools used to install and migrate AppArmor
 profiles. This is normally used from package maintainer scripts during
 install and removal.

Package: apparmor-easyprof
Architecture: all
Multi-Arch: foreign
Depends: ${python3:Depends}, ${misc:Depends}, python3-apparmor
Breaks: apparmor-utils (<< 2.8.0-0ubuntu14)
Replaces: apparmor-utils (<< 2.8.0-0ubuntu14)
Description: AppArmor easyprof profiling tool
 This provides the aa-easyprof utility which is an easy to use interface for
 AppArmor policy generation. aa-easyprof supports the use of templates and
 policy groups to quickly profile an application.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

export DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_HOST_MULTIARCH   ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export PERL_VENDORARCH := $(shell perl -MConfig -e 'print substr($$Config{vendorarch},1)' )
export PYTHON=/usr/bin/python3
export PYTHON_VERSION=3
export PYTHON_VERSIONS=python3

%:
	dh $@ --with=python2,python3,apache2,systemd


override_dh_auto_configure:
	cd libraries/libapparmor && sh ./autogen.sh
	dh_auto_configure -D libraries/libapparmor -- --with-perl --libdir /lib/$(DEB_HOST_MULTIARCH)


override_dh_auto_build:
	# Build perl
	dh_auto_build -D libraries/libapparmor
	# Build pythons
	set -e && for py in $(shell pyversions -s) $(shell py3versions -s) ; do \
		cp -a $(CURDIR)/libraries/libapparmor $(CURDIR)/libraries/libapparmor.$$py && \
		PYTHON=/usr/bin/$$py dh_auto_configure \
			-D libraries/libapparmor.$$py -- --with-python && \
		PYTHON=/usr/bin/$$py dh_auto_build \
			-D libraries/libapparmor.$$py; \
	done

	# Don't run '$(MAKE) check' because of too many perl dependencies
	# and various apparmor files installed on the system
	# Build pythons
	cd utils && $(MAKE)
	for py in $(shell pyversions -s) $(shell py3versions -s) ; do \
		cp -a $(CURDIR)/utils $(CURDIR)/utils.$$py && \
		(cd utils.$$py && PYTHON=/usr/bin/$$py $(MAKE)) ; \
	done
ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	cd binutils && $(MAKE) indep
	cd parser && $(MAKE) indep
else
	cd binutils && $(MAKE) V=1
	cd parser && $(MAKE) V=1
endif
	cd profiles && $(MAKE)


override_dh_auto_test:
ifeq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	dh_auto_test -Dbinutils -- V=1
	dh_auto_test -Dparser -- V=1
endif
	dh_auto_test -Dlibraries/libapparmor -- V=1
	set -e && for py in $(shell pyversions -s) $(shell py3versions -s) ; do \
		PYTHON=/usr/bin/$$py dh_auto_test \
			-D libraries/libapparmor.$$py -- PYTHON=/usr/bin/$$py; \
	done


override_dh_auto_clean:
	# Clean up from a Makefile.PL rebuild.
	cd libraries/libapparmor/swig/perl && if test -f Makefile.perl; then \
		$(MAKE) -fMakefile.perl realclean; \
	fi
	# Clean up from an autogen'd build.
	cd $(CURDIR)/libraries/libapparmor && \
		[ ! -f Makefile ] || $(MAKE) distclean
	# Clean up rest of build.
	set -e && for i in binutils utils parser profiles changehat/mod_apparmor \
		  changehat/pam_apparmor ; do \
		[ ! -f $$i/Makefile ] || $(MAKE) -C $$i clean; \
		rm -f $$i/common; \
	done
	# Remove the python build dirs
	rm -rf $(CURDIR)/libraries/libapparmor.python*
	rm -rf $(CURDIR)/utils.python*
	# Try to clean up from an autogen'd build
	cd libraries/libapparmor && [ ! -f Makefile ] || $(MAKE) distclean
	# Remove generated debhelper documentation.
	rm -f $(CURDIR)/debian/debhelper/dh_apparmor.1
	# Remove autoconf build cruft.
	rm -f $(CURDIR)/libraries/libapparmor/test-driver


override_dh_auto_install:
	# Utils
	cd utils && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install

	set -e && for py in $(shell pyversions -s) $(shell py3versions -s) ; do \
		(cd utils.$$py && PYTHON=/usr/bin/$$py $(MAKE) \
	    	DESTDIR=$(CURDIR)/debian/tmp \
	    	install) ; \
	done

	# Parser
ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	cd binutils && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install-indep

	install -D -m 755 $(CURDIR)/debian/non-linux/fake_apparmor_util \
		$(CURDIR)/debian/tmp/sbin/apparmor_parser
	install -D -m 755 $(CURDIR)/debian/non-linux/fake_apparmor_util \
		$(CURDIR)/debian/tmp/usr/bin/aa-enabled
	install -D -m 755 $(CURDIR)/debian/non-linux/fake_apparmor_util \
		$(CURDIR)/debian/tmp/usr/bin/aa-exec
	cd parser && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install-indep
else
	cd binutils && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install

	cd parser && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
endif

	# Changehat via libapparmor
	cd libraries/libapparmor && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# fixup rpath for libapparmor-perl
	find $(CURDIR)/debian/tmp/$(PERL_VENDORARCH) -name '*.so' | xargs chrpath --delete

	# Install python swig modules
	set -e && for py in $(shell pyversions -s) $(shell py3versions -s); do \
		PYTHON=/usr/bin/$$py \
		$(MAKE) -C libraries/libapparmor.$$py \
		DESTDIR=$(CURDIR)/debian/tmp install; \
	done

	# Changehat via mod_apparmor
	cd changehat/mod_apparmor && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# Fix rpath in mod_apparmor.so
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/apache2/modules/mod_apparmor.so

	# Changehat via libpam-apparmor
	cd changehat/pam_apparmor && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# Fix rpath in pam_apparmor.so
	chrpath -d $(CURDIR)/debian/tmp/lib/security/pam_apparmor.so

	# Profiles
	# We'd like to keep site.local from being a conffile
	rm ./profiles/apparmor.d/tunables/xdg-user-dirs.d/site.local
	cd profiles && $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    EXTRAS_DEST=$(CURDIR)/debian/tmp/usr/share/doc/apparmor-profiles/extras \
	    install
	# set all profiles in apparmor-profiles to complain mode
	cd $(CURDIR)/debian/tmp && sh $(CURDIR)/debian/put-all-profiles-in-complain-mode.sh

	# Build debhelper documentation.
	pod2man -c Debhelper -r "$(DEB_VERSION)" $(CURDIR)/debian/debhelper/dh_apparmor $(CURDIR)/debian/debhelper/dh_apparmor.1

	# Create unversioned link in /usr to the shared library
	MY_DSO=$$(basename $$(readlink $(CURDIR)/debian/tmp/lib/$(DEB_HOST_MULTIARCH)/libapparmor.so)); \
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$${MY_DSO} \
	    $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libapparmor.so

override_dh_installinit:
	dh_installinit --update-rcd-params='start 37 S .' --no-start --no-restart-on-upgrade --error-handler=true

override_dh_compress:
	dh_compress -Xextras

override_dh_perl:
	dh_perl -p libapparmor-perl -d
	dh_perl --no-package=libapparmor-perl

override_dh_apache2:
	dh_apache2 --noenable

override_dh_install:
	set -e && for profile in $(shell grep ^etc/apparmor.d/ $(CURDIR)/debian/apparmor-profiles.install | \
			 cut -d/ -f3- | grep -v /); do \
	    DH_AUTOSCRIPTDIR=debian/debhelper/ perl debian/debhelper/dh_apparmor --profile-name=$$profile -papparmor-profiles; \
	done
	sed -i -e 's,usr/lib/perl5,$(PERL_VENDORARCH),g' \
	    $(CURDIR)/debian/tmp/etc/apparmor/logprof.conf \
	    $(CURDIR)/debian/tmp/etc/apparmor/severity.db
	dh_install


VERSION_SEP=+
VERSION=$(shell  dpkg-parsechangelog | grep ^Version | cut -d$(VERSION_SEP) -f1 | cut -d\  -f2)
BZR_RELEASE=$(shell dpkg-parsechangelog | grep ^Version | cut -d$(VERSION_SEP) -f2 | cut -d. -f1 | cut -d- -f1 | sed -e 's/bzr//')
ORIG_FILE=$(CURDIR)/../apparmor_$(VERSION)$(VERSION_SEP)bzr$(BZR_RELEASE).orig.tar.gz
BZR_CO_DIR=$(CURDIR)/apparmor-$(VERSION)$(VERSION_SEP)bzr$(BZR_RELEASE)
get-orig-source:
	test ! -e $(ORIG_FILE)
	test ! -e $(BZR_CO_DIR)
	bzr checkout --lightweight -r $(BZR_RELEASE) lp:~apparmor-dev/apparmor/master $(BZR_CO_DIR)
	tar czf $(ORIG_FILE) -C `dirname $(BZR_CO_DIR)` --exclude .bzr `basename $(BZR_CO_DIR)`
	rm -rf $(BZR_CO_DIR)
